Attribute VB_Name = "Prophet32"
Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type
Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lparam As Any) As Long
    Public Const EM_GETLINECOUNT = &HBA
    Public Const EM_GETLINE = &HC4
Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
    Global Const HWND_NOTOPMOST = -2
    Global Const HWND_TOPMOST = -1
    Global Const SWP_NOMOVE = 2
    Global Const SWP_NOSIZE = 1
Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, lpKeyName As Any, ByVal lpDefault As String, ByVal lpRetunedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lplFileName As String) As Long
Declare Function ExitWindowsEx Lib "user32" (ByVal uFlags As Long, ByVal dwReserved As Long) As Long
Declare Function GetClassWord Lib "user32" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Declare Function DrawIcon Lib "user32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal hIcon As Long) As Long
Declare Function ExtractIcon Lib "shell32.dll" Alias "ExtractIconA" (ByVal hInst As Long, ByVal lpszExeFileName As String, ByVal nIconIndex As Long) As Long
    Const GWW_HINSTANCE = (-6)
    Const GCW_HMODULE = (-16)
Declare Function GetClassLong Lib "user32" Alias "GetClassLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
    Const GCL_HMODULE = (-16)

Function GetFromReg(start, path)
Dim X&, result&, thePath$
Dim buffer As String * 255
X& = RegOpenKey(start, vbNullString, result&)
X& = RegQueryValue(result&, path, buffer$, 255)
thePath = Mid(buffer$, 1, ((InStr(1, Trim(buffer$), ".exe") - 5)))
Let GetFromReg = buffer$
'RegOpenKey - used to open an existing key
'RegCreateKey - used to create a new key or open an existing key
'RegDeleteKey - used to delete an existing key
'RegCloseKey - used to close a key; does not delete it
'RegQueryValue - used to obtain the value of an open key
'RegSetValue - used to write a value to an open key

End Function

Function GetIcon(pic As PictureBox, IconPath, IconIndex As Integer)
Let IconIndex = IconIndex - 1
hIcon = ExtractIcon(VbNoString, IconPath, IconIndex)
lRet = DrawIcon(pic.hdc, 0, 0, hIcon)
End Function

Function CountIcons(path)
Let CountIcons = ExtractIcon(VbNoString, path, -1)
End Function

Function ExitWin()
Off = ExitWindowsEx(VbNoString, VbNoString)
End Function

Function OnTop(frm As Form, TopMost As Boolean)
Dim Value%
If TopMost = True Then Value% = SetWindowPos(frm.hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
If TopMost = False Then Value% = SetWindowPos(frm.hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
End Function

Function CenterForm(frm As Form)
    frm.Top = (Screen.Height * 0.85) / 2 - frm.Height / 2
    frm.Left = Screen.Width / 2 - frm.Width / 2
End Function

Function GetFromINI(AppName$, KeyName$, FileName$) As String
   Dim RetStr As String
   RetStr = String(255, Chr(0))
   GetFromINI = Left(RetStr, GetPrivateProfileString(AppName$, ByVal KeyName$, "", RetStr, Len(RetStr), FileName$))
End Function

Function SaveText(Text, OutputFile)
Open OutputFile For Output As #1
Print #1, Text
Close #1
End Function

Function LoadText(txt As TextBox, InputFile)
On Error GoTo Error
Dim X
Dim Y
Open InputFile For Input As #1
Let txt.Text = ""
Let Y = FileLen(InputFile)
X = Input(Y, #1)
Let txt.Text = txt.Text + X
Close #1
Exit Function
Error:
End Function

Function GetLine(txt As TextBox, Line As Long) As String
Dim A&, di&
Dim byteLo%, byteHi%, tstc%
Dim buffer$
Dim B
A = SendMessage(txt.hWnd, EM_GETLINECOUNT, 0&, 0&)
If Line > A Then Exit Function
Let Line = Line - 1
Let B = Len(txt.Text)
Let B = B + 2
byteLo = B And (255)
byteHi = Int(B / 256)
buffer = Chr(byteLo) + Chr(byteHi) + Space((B - 2))
di = SendMessage(txt.hWnd, EM_GETLINE, Line, buffer)
buffer = RTrim(buffer)
If Len(buffer) = 2 Then
    tstc = Asc(Right(buffer, 1))
    If tstc = 0 Or tstc = 3 Then buffer = ""
End If
GetLine = buffer
End Function

Function CountLines(txt As TextBox)
Dim A
A = SendMessage(txt.hWnd, EM_GETLINECOUNT, 0&, 0&)
Let A = A + 1
Let CountLines = A
End Function

Function Fade(frm As Form, Red1 As Integer, Green1 As Integer, Blue1 As Integer, Red2 As Integer, Green2 As Integer, Blue2 As Integer, Div As Integer)

Dim hBrush%
Dim FormHeight%
Dim StepInterval%
Dim X%
Dim RetVal%
Dim OldMode%
Dim FillArea As RECT
Dim RedC
Dim GreenC
Dim BlueC

Let RedC = ((Red1 - Red2) / (Div))
Let GreenC = ((Green1 - Green2) / (Div))
Let BlueC = ((Blue1 - Blue2) / (Div))

OldMode = frm.ScaleMode
frm.ScaleMode = 3

FormHeight = frm.ScaleHeight

StepInterval = FormHeight \ Div

FillArea.Left = 0
FillArea.Right = frm.ScaleWidth
FillArea.Top = 0
FillArea.Bottom = StepInterval

For X = 1 To 250
    
    If Red1 < 0 Then Let Red1 = 0
    If Red1 > 255 Then Let Red1 = 255
    If Green1 < 0 Then Let Green1 = 0
    If Green1 > 255 Then Let Green1 = 255
    If Blue1 < 0 Then Let Blue1 = 0
    If Blue1 > 255 Then Let Blue1 = 255
    
    hBrush% = CreateSolidBrush(RGB(Red1, Green1, Blue1))
    RetVal% = FillRect(frm.hdc, FillArea, hBrush%)
    RetVal% = DeleteObject(hObject)

    Let Red1 = Red1 - RedC
    Let Blue1 = Blue1 - BlueC
    Let Green1 = Green1 - GreenC

    FillArea.Top = FillArea.Bottom
    FillArea.Bottom = FillArea.Bottom + StepInterval
Next
    
FillArea.Bottom = FillArea.Bottom + Div

hBrush% = CreateSolidBrush(RGB(Red2, Green2, Blue2))
RetVal% = FillRect(frm.hdc, FillArea, hBrush)
RetVal% = DeleteObject(hBrush)

frm.ScaleMode = OldMode

End Function

